<?php
/*
Plugin Name: GA Image Carousel
Plugin URI: http://www.graphicarea.pro/en/ga-image-carousel-v1-en
Description: Simple and light image carousel with animation and fancybox.
Version: 1.0.3
Author: Anatoly Ludischev
Author URI: http://www.graphicarea.pro
*/

function ga_wp_add_basic_scripts()  
{  
    wp_register_script( 'ga-image-carousel-script', plugins_url( '/ga-image-carousel.js', __FILE__ ), array( 'jquery' ) );
    wp_enqueue_script( 'ga-image-carousel-script' );
    wp_register_script( 'jquery-fancybox', plugins_url( '/fancybox/jquery.fancybox.min.js', __FILE__ ));
    wp_enqueue_script( 'jquery-fancybox' );
    wp_register_style( 'fancybox', plugins_url( '/fancybox/jquery.fancybox.min.css', __FILE__ ), 'all' ); 
    wp_enqueue_style( 'fancybox' );  
}  

add_action( 'wp_enqueue_scripts', 'ga_wp_add_basic_scripts' );
add_image_size( 'ga-image-size', 500, 500, array( 'center', 'center' ));


function ga_gallery_image_carousel($args) {

	$config = array('autoplay' => '1',
					'theme' => 'basic',
					'width' => '100%',
					'width-item' => '150',
					'proportion' => '1:1',
					'fancy' => '1',
					'random' => '0',
					'animation' => 'bysection',
					'direction' => 'right',
					'delay' => '5',
					'duration' => '0.4', 
					'clickable' => '1',
					'caption' => '1',
					'border' => '10',
					'border-color' => '#ffffff',
					'border-radius' => '0',
					'margin' => '10',
					'navigation' => '1',
	);
	
	$user_config = "";
	$image_caption = "";
	$proportion = 0;

	if(isset ($args['theme'])){$config['theme'] = $args['theme'];}
	$ga_theme = 'ga-image-carousel-style-'.$config['theme'];
	wp_register_style( $ga_theme, plugins_url( '/ga-image-carousel-'.$config['theme'].'.css', __FILE__ ), 'all' ); 
    wp_enqueue_style( $ga_theme );
	foreach ($config as $key => $value) {
		if (isset ($args[$key])) {
			if ($args[$key] != $config[$key]) {
				$config[$key] = $args[$key];
				$user_config .= 'data-'.$key.'="'.$args[$key].'"';
			}			
		}
	}
	$ga_size = array($config['width-item'], $config['width-item']);
	if ($config['proportion'] != 'auto') {
			$proportion = explode(":", $config['proportion']);
			$proportion = $proportion[0] / $proportion[1];
	}
	if ($proportion == 1) {
		$ga_size = 'ga-image-size' ;
	}
	$ids = explode(',', $args['ids']);
	$first_image_atr = wp_get_attachment_image_src( $ids[0], 'full' );
	
	$user_config .= 'data-imgwidth="'.$first_image_atr[1].'" data-imgheight="'.$first_image_atr[2].'"';
	
	if($config['random'] == 1){shuffle($ids);}
	
	$html = '<div class="ga-v-centered '.$config['theme'].'">
			 <div class="ga-carousel" '.$user_config.'>
			 <div class="ga-roll">';
			 
	foreach ($ids as $id) {

		$image_attributes = wp_get_attachment_image_src( $id, 'full' );		
		if($config['caption'] == 1){$image_caption = '<p>'.wp_get_attachment_caption( $id ).'</p>';}
		if($config['clickable'] == 1){			
			if($config['fancy'] == 1){
				$html.= '<div class="ga-project"><div><a href="'.$image_attributes[0].'" data-fancybox="ga1" data-caption="'.wp_get_attachment_caption( $id ).'">';
			} else {
				$html.= '<div class="ga-project"><div><a href="'.$image_attributes[0].'" data-caption="'.wp_get_attachment_caption( $id ).'">';
			}	


			$html.= wp_get_attachment_image( $id, $ga_size).'</a></div>'.$image_caption.'</div>';	
		} else {
				$html.= '<div class="ga-project"><div>'.wp_get_attachment_image( $id, $ga_size).'</div>'.$image_caption.'</div>';	
		}
	
	}

	$html.= '</div><div class="ga-sections"></div><button id="ga-nav-left" class="ga-navigation"><img src="'.plugins_url( 'images/ga-arrow-l.png', __FILE__ ).'"></button><button id="ga-nav-right" class="ga-navigation"><img src="'.plugins_url( 'images/ga-arrow-r.png', __FILE__ ).'"></button></div></div>';
			 
	return $html ;
} 

add_shortcode( 'ga-carousel', 'ga_gallery_image_carousel' );
?>
